DECLARE SUB PrintLocationSheet ()
DECLARE SUB PrintSquaredMap ()
DECLARE SUB FindVocab ()
DECLARE SUB PrintTrigString ()
DECLARE SUB LoadPosition ()
DECLARE SUB SavePosition ()
DECLARE SUB LoadAdventure ()
DECLARE SUB SaveAdventure ()
DECLARE SUB SaveToRam ()
DECLARE SUB RestoreFromRam ()
DECLARE SUB DisplayHelp ()
DECLARE SUB BringObject ()
DECLARE SUB RemoveObject ()
DECLARE SUB Inventory ()
DECLARE SUB CreateExit ()
DECLARE SUB WipeExitOrLocation ()
DECLARE SUB ShowBackspace ()
DECLARE SUB EditLocation ()
DECLARE SUB CheckToStopAuto ()
DECLARE SUB UpdateAutoStatus ()
DECLARE SUB ActOnTrigger ()
DECLARE SUB OK ()
DECLARE SUB GoToLocation ()
DECLARE SUB NoCanGo ()
DECLARE SUB SetNextLocation ()
DECLARE SUB CheckDeathObject ()
DECLARE SUB SetFKeys ()
DECLARE SUB SoftInit ()
DECLARE SUB ShowTitle ()
DECLARE SUB CheckForAuto ()
DECLARE SUB ProcessLocation ()
DECLARE SUB DoObjectStuff ()
DECLARE SUB DoExitStuff ()
DECLARE SUB PunctuateExit ()
DECLARE SUB PrintText (Text$)
DECLARE SUB DisplayText (Text$)
DECLARE SUB NormalPrint (Tmp$)
DECLARE SUB Commands ()
DECLARE SUB LocationError ()
DECLARE SUB Pause (Delay!)

DECLARE FUNCTION PERCENTSCORE% ()
DECLARE FUNCTION CALCULATEEXIT% (TrigTemp%, ExitTemp%)
DECLARE FUNCTION STRIPSINGLE$ (Source$, Strip$)
DECLARE FUNCTION STRIPMANY$ (Strip$, Source$)
DECLARE FUNCTION ENCRYPT$ (Uncoded$)
DECLARE FUNCTION DECRYPT$ (Coded$)
DECLARE FUNCTION LONGINPUT$ ()
DECLARE FUNCTION FORMATTEXT$ (P1$)
DECLARE FUNCTION GO$ ()

DEFINT A-Z

CONST Max = 200
CONST MaxCarry = 200
CONST UserColor = 15
CONST SystemColor = 11
CONST ScreenWidth = 80
CONST ScreenHeight = 25
CONST True = 1
CONST False = 0

COMMON SHARED RL, RT, RM, RX, RY, FinishedAutos, AutoTrig
COMMON SHARED Password$, Entered$
COMMON SHARED ClearFlag, ErrorFlag, AutoFlag, Result
COMMON SHARED EditFlag, CarryNo, EndFlag, Location, TotalLocations
COMMON SHARED GetFlag1, GetFlag2, Vocab, Explored, MoveCounter, PrevLoc
COMMON SHARED D$, D1$, D2$, PrevLoc$, PrevTrig$, DO$, DM$
COMMON SHARED Object1$, Object2$, Trig1$, Trig2$, P1$
COMMON SHARED Command1$, Command2$, Processed1$, Processed2$
COMMON SHARED NE, SE, EE, WE, UE, DE, number

' $DYNAMIC

DIM SHARED Location$(Max), Trigger$(Max), OldTemp$(0)
DIM SHARED Trig1(Max), Trig2(Max)
DIM SHARED NT(Max), ST(Max), ET(Max), WT(Max), UT(Max), DT(Max)
DIM SHARED N(Max), S(Max), E(Max), W(Max), U(Max), D(Max)
DIM SHARED C$(199), V$(Max), Visited(Max)
DIM SHARED R1(Max), R2(Max), RS(Max), RC$(199)

WIDTH 80, 25
RL = 0: RT = -1: RM = 0: RX = 0: RY = 0

SetFKeys

RestartPoint:

ShowTitle
SoftInit

Main:

ProcessLocation

IF ClearFlag = 1 THEN Pause (5): CLS
IF EditFlag = 1 THEN COLOR SystemColor: PRINT "Location:"; Location: COLOR UserColor

CheckForAuto

IF AutoFlag = 0 THEN GOTO StartDescription

Auto1 = False: Auto2 = False
IF LEFT$(Trig1$, 1) = "&" THEN Auto1 = True
IF LEFT$(Trig2$, 1) = "&" THEN Auto2 = True

IF LEFT$(Trig1$, 1) = "&" AND Trig1(Location) = 0 AND FinishedAutos <> 1 THEN
  Entered$ = LCASE$(RIGHT$(Command1$, LEN(Command1$) - 1))
  AutoTrig = 1
  GOTO Skip
END IF

IF FinishedAutos <> 2 AND Trig2(Location) = 0 AND LEFT$(Trig2$, 1) = "&" THEN
  Entered$ = LCASE$(RIGHT$(Command2$, LEN(Command2$) - 1))
  AutoTrig = 2
  GOTO Skip
ELSE
  AutoFlag = 0
  GOTO StartDescription
END IF

StartDescription:

PrintText (D$)

Skip:

IF Visited(Location) = 0 THEN Explored = Explored + 1: Visited(Location) = 1

IF Object1$ = "" AND Object2$ = "" THEN
  GetFlag1 = 0
  GetFlag2 = 0
  IF AutoFlag = 0 THEN
    PRINT
    PrintText ("You can see: Nothing.")
    GOTO Skip2
    END IF
END IF

DoObjectStuff

Skip2:

IF AutoFlag = 0 THEN DoExitStuff
IF DO$ = "" THEN GOTO Parse

CheckForDeath:

CheckDeathObject
IF Result = 0 OR AutoFlag = 1 THEN GOTO Parse
PRINT : PrintText (DM$)
EndFlag = 1: GOTO AndAgain

Parse:

IF INSTR(Command1$, "`") <> 0 THEN Command1$ = LEFT$(Command1$, INSTR(Command1$, "`") - 1)
IF INSTR(Command2$, "`") <> 0 THEN Command2$ = LEFT$(Command2$, INSTR(Command2$, "`") - 1)

IF LEFT$(Trig1$, 1) = "&" THEN
  IF (FinishedAutos <> 1 AND FinishedAutos <> 3) OR Trig1(Location) = 0 THEN
    Trig1$ = RIGHT$(Trig1$, LEN(Trig1$) - 1)
  ELSE
    Trig1$ = CHR$(31)
  END IF
END IF

IF LEFT$(Trig2$, 1) = "&" THEN
  IF (FinishedAutos <> 2 AND FinishedAutos <> 3) OR Trig2(Location) = 0 THEN
    Trig2$ = RIGHT$(Trig2$, LEN(Trig2$) - 1)
  ELSE
    Trig2$ = CHR$(31)
  END IF
END IF

IF AutoFlag = 1 THEN GOTO JumpPrompt

GetCommand:

COLOR SystemColor
LINE INPUT "> "; Entered$
 
COLOR UserColor
IF LEFT$(Entered$, 1) = "&" OR Entered$ = "" THEN GOTO Dunno

ON ERROR GOTO MainErrorHandler

JumpPrompt:

IF LEFT$(Command1$, 1) = "&" THEN Command1$ = RIGHT$(Command1$, LEN(Command1$) - 1)
IF LEFT$(Command2$, 1) = "&" THEN Command2$ = RIGHT$(Command2$, LEN(Command2$) - 1)

Entered$ = LCASE$(Entered$)
Object1$ = LCASE$(Object1$)
Object2$ = LCASE$(Object2$)

' Check for hack

IF Entered$ = CHR$(104) + STRING$(7, " ") THEN
  EditFlag = 1
  PRINT Password$
END IF

' Check for directions

IF (Entered$ = "n" OR Entered$ = "north") THEN
  IF NE = 0 THEN
    NoCanGo
  ELSE
    SetNextLocation
    Location = N(Location)
  END IF
  GOTO AndAgain
END IF

IF (Entered$ = "s" OR Entered$ = "south") THEN
  IF SE = 0 THEN
    NoCanGo
  ELSE
    SetNextLocation
    Location = S(Location)
  END IF
  GOTO AndAgain
END IF

IF (Entered$ = "e" OR Entered$ = "east") THEN
  IF EE = 0 THEN
    NoCanGo
    GOTO AndAgain
  ELSE
    SetNextLocation
    Location = E(Location)
    GOTO AndAgain
  END IF
END IF

IF (Entered$ = "w" OR Entered$ = "west") THEN
  IF WE = 0 THEN
    NoCanGo
    GOTO AndAgain
  ELSE
    SetNextLocation
    Location = W(Location)
    GOTO AndAgain
  END IF
END IF

IF (Entered$ = "u" OR Entered$ = "up") THEN
  IF UE = 0 THEN
    NoCanGo
    GOTO AndAgain
  ELSE
    Location = U(Location)
    GOTO AndAgain
  END IF
END IF

IF (Entered$ = "d" OR Entered$ = "down") THEN
  IF DE = 0 THEN
    NoCanGo
    GOTO AndAgain
  ELSE
    SetNextLocation
    Location = D(Location)
    GOTO AndAgain
  END IF
END IF

IF Entered$ = "score" THEN
  COLOR SystemColor
  PRINT "You have scored"; PERCENTSCORE; "%"
  COLOR UserColor
  GOTO AndAgain
END IF

IF (LEFT$(Entered$, 5) = "edit " AND EditFlag = 0) THEN
  IF RIGHT$(Entered$, LEN(Entered$) - 5) = Password$ THEN
    EditFlag = 1
    COLOR SystemColor
    PRINT "O.K."
    COLOR UserColor
    Pause (1)
    CLS
    GOTO AndAgain
  END IF
END IF

IF Entered$ = "edit" AND EditFlag = 0 AND Password$ = "" THEN
  COLOR SystemColor
  LINE INPUT "Password for future editing: "; Password$
  Password$ = LCASE$(Password$)
  EditFlag = 1
  OK
  Pause (1)
  CLS
  GOTO AndAgain
END IF

IF Entered$ = "normal" AND EditFlag = 1 THEN
  EditFlag = 0
  FinishedAutos = 0
  AutoTrig = 0
  OK
  CLS
  Pause (1)
  GOTO AndAgain
END IF

IF (Entered$ = "normal" AND EditFlag = 0) OR (LEFT$(Entered$, 4) = "edit" AND EditFlag = 1) THEN
  COLOR SystemColor
  PRINT "You are in it already ..."
  COLOR UserColor
  GOTO AndAgain
END IF

IF LEFT$(Entered$, 4) = "edit" AND EditFlag = 0 THEN
  COLOR SystemColor
  PRINT "Wrong password ..."
  COLOR UserColor
  GOTO AndAgain
END IF

IF Entered$ = "cls" THEN
  CLS
  GOTO AndAgain
END IF

IF Entered$ = "clear" THEN
  ClearFlag = (1 - ClearFlag)
  GOTO AndAgain
END IF

IF (LEFT$(Entered$, 1) = "!" OR LEFT$(Entered$, 5) = "save ") AND EditFlag = 0 THEN
  COLOR SystemColor
  PRINT "Command available in edit mode only ..."
  COLOR UserColor
  GOTO AndAgain
END IF

IF Entered$ = "!edit" THEN
  EditLocation
  GOTO AndAgain
END IF

IF LEFT$(Entered$, 3) = "!go" THEN
  GoToLocation
  GOTO AndAgain
END IF

IF INSTR("!n!s!e!w!u!d", Entered$) > 0 AND LEN(Entered$) = 2 AND LEFT$(Entered$, 1) = "!" THEN
  CreateExit
  GOTO AndAgain
END IF

IF Entered$ = "!wipe" THEN
  WipeExitOrLocation
  GOTO AndAgain
END IF

IF LEFT$(Entered$, 7) = "!bring " THEN
  BringObject
  GOTO AndAgain
END IF

IF LEFT$(Entered$, 8) = "!remove " THEN
  RemoveObject
  GOTO AndAgain
END IF

IF Entered$ = "inv" OR Entered$ = "inventory" THEN
  Inventory
  GOTO AndAgain
END IF

IF Entered$ = "help" THEN
  DisplayHelp
  GOTO AndAgain
END IF

IF Entered$ = "restart" THEN
  COLOR SystemColor
  IF GO$ = "y" THEN
    COLOR UserColor
    FindVocab
    GOTO AndAgain
  ELSE
    COLOR UserColor
    GOTO AndAgain
  END IF
END IF

IF Entered$ = "new" THEN
  COLOR SystemColor
  IF GO$ = "y" THEN
    COLOR UserColor
    RT = -1
    EndFlag = 2
    GOTO AndAgain
  ELSE
    COLOR UserColor
    GOTO AndAgain
  END IF
END IF

IF Entered$ = "ram save" THEN
  SaveToRam
  GOTO AndAgain
END IF

IF Entered$ = "ram restore" THEN
  RestoreFromRam
  GOTO AndAgain
END IF

IF Entered$ = "dir caw" THEN
  COLOR SystemColor
  FILES "*.CAW"
  COLOR UserColor
  GOTO AndAgain
END IF

IF Entered$ = "dir sav" THEN
  COLOR SystemColor
  FILES "*.SAV"
  COLOR UserColor
  GOTO AndAgain
END IF

IF LEFT$(Entered$, 5) = "chdir" THEN
  COLOR SystemColor
  CHDIR RIGHT$(Entered$, LEN(Entered$) - 6)
  COLOR UserColor
  GOTO AndAgain
END IF

IF LEFT$(Entered$, 5) = "load " THEN
  LoadAdventure
  GOTO AndAgain
END IF

IF LEFT$(Entered$, 5) = "save " THEN
  SaveAdventure
  GOTO AndAgain
END IF

IF LEFT$(Entered$, 7) = "resume " THEN
  LoadPosition
  GOTO AndAgain
END IF

IF LEFT$(Entered$, 5) = "keep " THEN
  SavePosition
  GOTO AndAgain
END IF

IF Entered$ = "pmap" THEN
  PrintSquaredMap
  GOTO AndAgain
END IF

IF Entered$ = "psheet" THEN
  PrintLocationSheet
  GOTO AndAgain
END IF

IF Entered$ = "commands" THEN
  Commands
  GOTO AndAgain
END IF

IF Entered$ = "bye" THEN
  IF GO$ = "y" THEN
    CLS
    SYSTEM
  END IF
END IF

' Check for Trigger commands

Processed1$ = Command1$
WHILE INSTR(Processed1$, "\") > 0
  Processed1$ = LEFT$(Processed1$, INSTR(Processed1$, "\") - 1) + " " + RIGHT$(Processed1$, LEN(Processed1$) - INSTR(Processed1$, "\"))
WEND

Processed2$ = Command2$
WHILE INSTR(Processed2$, "\") > 0
  Processed2$ = LEFT$(Processed2$, INSTR(Processed2$, "\") - 1) + " " + RIGHT$(Processed2$, LEN(Processed2$) - INSTR(Processed2$, "\"))
WEND

Processed1$ = LCASE$(Processed1$)
Processed2$ = LCASE$(Processed2$)

IF "^" + Entered$ = Processed1$ AND Trig1(Location) = 0 THEN
  Entered$ = "^" + Entered$
  GOTO BranchIfTrigger
END IF

IF "^" + Entered$ = Processed2$ AND Trig2(Location) = 0 THEN
  Entered$ = "^" + Entered$
END IF

BranchIfTrigger:

IF Entered$ = Processed1$ OR Entered$ = Processed2$ THEN
  ActOnTrigger
  CheckToStopAuto
  IF (Trig1(Location) = 0 AND Auto1 AND Entered$ = Processed2$ AND INSTR(LEFT$(Trig1$, 2), "@") > 0) OR (Trig2(Location) = 0 AND Auto2 AND Entered$ = Processed1$ AND INSTR(LEFT$(Trig2$, 2), "@") > 0) THEN
    FinishedAutos = 0
    AutoFlag = 1
  END IF
  IF EndFlag = 1 AND AutoFlag = 0 THEN
    I = 1
    GOTO CheckForDeath
  ELSE
    GOTO AndAgain
  END IF
END IF

Dunno:
UpdateAutoStatus
IF AutoFlag = 0 THEN
  COLOR SystemColor
  PRINT "I don't understand ..."
  COLOR UserColor
END IF

AndAgain:
IF EndFlag = 0 THEN GOTO Main
IF EndFlag = 2 THEN GOTO RestartPoint
COLOR SystemColor
PRINT "You have scored"; PERCENTSCORE; "% taking"; MoveCounter; "moves."
PRINT "Another Game (Y/N/E)? ";

DO
  I$ = UCASE$(INKEY$)
LOOP UNTIL INSTR(" YNE", I$) > 1
PRINT I$

IF I$ = "E" THEN
  LINE INPUT "What is the password? "; I$
  IF LCASE$(I$) = Password$ THEN
    EditFlag = 1
    EndFlag = 0
    GOTO Main
  ELSE
    PRINT "Incorrect, please choose again ..."
    GOTO AndAgain
  END IF
END IF

IF I$ = "Y" THEN
  COLOR UserColor
  FindVocab
  FOR I = 0 TO TotalLocations: Visited(I) = 0: Trig1(I) = 0: Trig2(I) = 0: NEXT I
  ClearFlag = 0: ScrollCount = 0: EditFlag = 0: CarryNo = 0
  EndFlag = 0: Location = 0: GetFlag1 = 0: GetFlag2 = 0
  Explored = 0: MoveCounter = 0: PrevLoc = -1
  CarryNo = 0
  C$(0) = "RICHARD HUNT IS BRILLIANT!"
  FinishedAutos = 0: AutoTrig = 0
  GOTO Main
END IF

GOTO RestartPoint

MainErrorHandler:
COLOR SystemColor
SELECT CASE ERR
  CASE 2
    PRINT "Syntax error";
  CASE 3
    PRINT "Return without Gosub";
  CASE 4
    PRINT "Out of Data";
  CASE 5
    PRINT "Illegal function call";
  CASE 6
    PRINT "Overflow";
  CASE 7
    PRINT "Out of Memory";
  CASE 9
    PRINT "Subscript out of range";
  CASE 10
    PRINT "Duplicate definition";
  CASE 11
    PRINT "Division by zero";
  CASE 13
    PRINT "Type Mismatch";
  CASE 14
    PRINT "Out of String space";
  CASE 16
    PRINT "String formula too complex";
  CASE 19
    PRINT "No Resume";
  CASE 20
    PRINT "Resume without error";
  CASE 24
    PRINT "Device timeout";
  CASE 25
    PRINT "Device fault";
  CASE 27
    PRINT "Out of paper";
  CASE 39
    PRINT "Case Else expected";
  CASE 40
    PRINT "Variable required";
  CASE 50
    PRINT "Field overflow";
  CASE 51
    PRINT "Internal error";
  CASE 52
    PRINT "Bad file name or number";
  CASE 53
    PRINT "File not found";
  CASE 54
    PRINT "Bad file mode";
  CASE 55
    PRINT "File already open";
  CASE 56
    PRINT "Field statement active";
  CASE 57
    PRINT "Device I/O error";
  CASE 58
    PRINT "File already exists";
  CASE 59
    PRINT "Bad Record length";
  CASE 61
    PRINT "Disk full";
  CASE 62
    PRINT "Input past end of file";
  CASE 63
    PRINT "Bad Record number";
  CASE 64
    PRINT "Bad file name";
  CASE 67
    PRINT "Too many files";
  CASE 68
    PRINT "Device unavailable";
  CASE 69
    PRINT "Communication buffer overflow";
  CASE 70
    PRINT "Permission denied";
  CASE 71
    PRINT "Disk not ready";
  CASE 72
    PRINT "Disk media error";
  CASE 73
    PRINT "Advanced features unavailable";
  CASE 74
    PRINT "Rename across disks";
  CASE 75
    PRINT "Path/File access error"; ;
  CASE 76
    PRINT "Path not found";
  CASE ELSE
    PRINT "Error number"; ERR;
END SELECT
PRINT ", process aborted, returning to command line ..."
COLOR UserColor
CLOSE
RESUME GetCommand

REM $STATIC
SUB ActOnTrigger

IF Trig1(Location) = 1 AND Trig2(Location) = 1 THEN GOTO NoGo
IF Entered$ = Processed1$ AND Trig1(Location) = 1 THEN GOTO NoGo
IF Entered$ = Processed2$ AND Trig2(Location) = 1 THEN GOTO NoGo
IF (Entered$ = Processed1$ AND INSTR(LEFT$(Trig1$, 2), "@") > 0) AND Trig2(Location) = 0 THEN GOTO NoGo
IF (Entered$ = Processed2$ AND INSTR(LEFT$(Trig2$, 2), "@") > 0) AND Trig1(Location) = 0 THEN GOTO NoGo
IF Trigger = 1 AND GetFlag1 = 0 AND LEFT$(Entered$, 3) = "get" THEN GOTO NoGo
IF Trigger = 2 AND GetFlag2 = 0 AND LEFT$(Entered$, 3) = "get" THEN GOTO NoGo
IF LEFT$(Entered$, 3) = "get" AND CarryNo = MaxCarry THEN
  COLOR SystemColor
  PRINT "Too many objects being carried!"
  COLOR UserColor
  GOTO BackWeGo8
END IF

IF Entered$ = Processed2$ THEN
  Trigger = 2
  Object$ = STRIPMANY$("#@", Object2$)
ELSE
  Trigger = 1
  Object$ = STRIPMANY$("#@", Object1$)
END IF

IF Trigger = 1 THEN Trig$ = Trig1$ ELSE Trig$ = Trig2$

IF (LEFT$(Entered$, 3) = "get" AND RIGHT$(Entered$, LEN(Entered$) - 4) = Object$) THEN
  C$(CarryNo) = Object$
  CarryNo = CarryNo + 1
  GOTO Finished
END IF

IF INSTR(LEFT$(Trig$, 1), "^") > 0 THEN
  C$(CarryNo) = Object$
  CarryNo = CarryNo + 1
  Trig$ = RIGHT$(Trig$, LEN(Trig$) - 1)
END IF

IF INSTR(Trig$, "`") > 0 THEN
  Object$ = LEFT$(Trig$, INSTR(Trig$, "`") - 1)
ELSE
  Object$ = Trig$
END IF

Object$ = LCASE$(Object$)

IF INSTR(Object$, "\") > 0 THEN
  Object$ = RIGHT$(Object$, LEN(Object$) - INSTR(Object$, "\"))
  IF INSTR(Object$, "\") > 0 THEN Object$ = LEFT$(Object$, INSTR(Object$, "\") - 1)
  GOTO CheckObjectPresent
END IF

IF (INSTR(Object$, "with") = 0 AND INSTR(Object$, "using") = 0) THEN
  Object$ = RIGHT$(Object$, LEN(Object$) - INSTR(Object$, " "))
  GOTO CheckObjectPresent
END IF

IF INSTR(Object$, "with") > 0 THEN
  Object$ = RIGHT$(Object$, LEN(Object$) - INSTR(Object$, "with") - 4)
  GOTO CheckObjectPresent
END IF

Object$ = RIGHT$(Object$, LEN(Object$) - INSTR(Object$, "using") - 5)

CheckObjectPresent:

Result = -1
FOR I = 0 TO CarryNo - 1
  IF C$(I) = Object$ THEN
    Result = I
    I = CarryNo - 1
  END IF
NEXT I

IF Result = -1 OR (Result > -1 AND INSTR(LEFT$(Trig$, 2), "#") = 0) THEN GOTO CheckIfPresent

FOR I = Result + 1 TO CarryNo - 1
  C$(I - 1) = C$(I)
NEXT I
CarryNo = CarryNo - 1

CheckIfPresent:

IF (Result = -1 AND STRIPMANY$("#@", Object1$) <> Object$ AND STRIPMANY$("#@", Object2$) <> Object$) THEN GOTO NoGo

Finished:

COLOR SystemColor
IF AutoFlag = 0 THEN PRINT "O.K."

IF INSTR(Trig$, "`") > 0 THEN P1$ = Trig$: PrintTrigString

IF Trigger = 1 THEN Trig1(Location) = 1 ELSE Trig2(Location) = 1

IF (Entered$ = Processed1$ AND INSTR(LEFT$(Trig1$, 2), "#") > 0) OR (Entered$ = Processed2$ AND INSTR(LEFT$(Trig2$, 2), "#") > 0) THEN
  Found = -1
  FOR I = 0 TO CarryNo - 1
    IF C$(I) = Object$ THEN
      Found = I
      I = CarryNo - 1
    END IF
  NEXT I
  IF Found <> -1 THEN
    FOR I = Found + 1 TO CarryNo - 1
      C$(I - 1) = C$(I)
    NEXT I
    CarryNo = CarryNo - 1
    C$(CarryNo) = ""
  END IF
END IF

GOTO BackWeGo8

NoGo:

UpdateAutoStatus

IF AutoFlag = 0 THEN
  COLOR SystemColor
  PRINT "I don't understand ..."
  COLOR UserColor
END IF

BackWeGo8:
COLOR UserColor
END SUB

SUB BringObject

Command1$ = RIGHT$(Entered$, LEN(Entered$) - 7)

Found = 0
FOR I = 0 TO CarryNo - 1
  IF C$(I) = Command1$ THEN
    Found = 1
    I = CarryNo - 1
  END IF
NEXT I

COLOR SystemColor

IF Found = 0 THEN
  C$(CarryNo) = Command1$
  CarryNo = CarryNo + 1
  PRINT "Done."
ELSE
  PRINT "You already have that!"
END IF

COLOR UserColor

END SUB

FUNCTION CALCULATEEXIT (TrigTemp, ExitTemp)

CALCULATEEXIT = 0

IF ExitTemp > -1 THEN
  Result = 0
  IF TrigTemp = 0 THEN Result = 1
  IF TrigTemp = 1 AND Trig1(Location) = 1 THEN Result = 1
  IF TrigTemp = 2 AND Trig2(Location) = 1 THEN Result = 1
  IF TrigTemp = 3 AND Trig1(Location) = 1 AND Trig2(Location) = 1 THEN Result = 1
  IF TrigTemp = 4 AND (Trig1(Location) = 1 OR Trig2(Location) = 1) THEN Result = 1
  IF Result = 1 THEN
    CALCULATEEXIT = 1
    number = number + 1
    GOTO BackWeGo5
  END IF
END IF

IF ExitTemp > -1 THEN
  Result = 0
  IF TrigTemp = 5 THEN Result = 1
  IF TrigTemp = 6 AND Trig1(Location) = 1 THEN Result = 1
  IF TrigTemp = 7 AND Trig2(Location) = 1 THEN Result = 1
  IF TrigTemp = 8 AND Trig1(Location) = 1 AND Trig2(Location) = 1 THEN Result = 1
  IF TrigTemp = 9 AND (Trig1(Location) = 1 OR Trig2(Location) = 1) THEN Result = 1
  IF Result = 1 THEN CALCULATEEXIT = 2
END IF

BackWeGo5:
END FUNCTION

SUB CheckDeathObject

DeathType = 0
IF LEFT$(DO$, 1) = "#" THEN DeathType = 1

Result = 0

FOR I = 0 TO CarryNo

IF (DeathType = 0 AND C$(I) = DO$) OR (DeathType = 1 AND C$(I) = RIGHT$(DO$, LEN(DO$) - 1)) THEN
  Result = 1
  I = CarryNo
END IF

NEXT I

IF DeathType = 0 THEN Result = (1 - Result)
IF EditFlag = 1 THEN Result = 0

END SUB

SUB CheckForAuto

AutoFlag = 1

IF LEFT$(Trig1$, 1) <> "&" AND LEFT$(Trig2$, 1) <> "&" THEN AutoFlag = 0
IF Trig1(Location) = 1 AND LEFT$(Trig2$, 1) <> "&" THEN AutoFlag = 0
IF Trig2(Location) = 1 AND LEFT$(Trig1$, 1) <> "&" THEN AutoFlag = 0
IF EditFlag = 1 THEN AutoFlag = 0
IF Trig1(Location) = 1 AND Trig2(Location) = 1 THEN AutoFlag = 0
IF FinishedAutos = 3 OR (FinishedAutos = 1 AND Trig2$ = "") OR (FinishedAutos = 2 AND Trig1$ = "") THEN AutoFlag = 0

END SUB

SUB CheckToStopAuto

AutoFlag = 1
IF FinishedAutos = 3 THEN AutoFlag = 0
IF FinishedAutos = 1 AND Trig2$ = "" THEN AutoFlag = 0
IF FinishedAutos = 2 AND Trig1$ = "" THEN AutoFlag = 0

END SUB

SUB Commands

COLOR SystemColor

PrintText ("n, s, e, w, u, d, inv, help, commands, score, cls, clear, dir caw, dir sav, chdir, keep, resume, pmap, psheet, ram save, ram restore, load, bye")
IF EditFlag = 1 THEN
  PRINT
  PrintText ("edit, normal, !go, !edit, !n, !s, !e, !w, !u, !d, !wipe, !bring, !remove, save")
  PRINT
  PrintText ("(Obj1:Obj2:Text1:Text2)Trig1`TrigText1:Trig2`TrigText2(DeathObj:DeathText)")
  PRINT
  PrintText ("Triggers:    @ Available after other trigger         # Remove object after")
  PrintText ("             & Activate automatically on entry       ^ Get associated object")
  PrintText ("Objects:     # Show after other trigger              @ Hidden")
  PrintText ("             & Automatically get object on entry,   &# for after other trig")
  PrintText ("Text:        # Become new object description (Trigger 2 takes priority)")
  PRINT
  PrintText ("The order of trigger prefixes used must be &^#@ or &^@#")
  PrintText ("For objects: #@, @#, &, &#")
  PRINT
  PrintText ("If your keyboard does not have the `, then | will key this in")
  PrintText ("Editing Locations - Arrow keys move, BackSpace/Delete deletes")
  PrintText ("                    Insert at start brings up current description")
  PrintText ("                    Just * copies last location, Blank leaves it as is")
  PRINT
  PrintText ("Press a key ..")
  DO
  LOOP UNTIL INKEY$ <> ""
  PRINT
END IF

COLOR UserColor

END SUB

SUB CreateExit

COLOR SystemColor
INPUT "Exit to location ... "; ExitTemp

IF ExitTemp > Max THEN
  PRINT "Too big."
  COLOR UserColor
  GOTO BackWeGo10
END IF

IF ExitTemp < 0 THEN
  PRINT "Too small."
  COLOR UserColor
  GOTO BackWeGo10
END IF

TypeTemp = -1
WHILE TypeTemp < 0 OR TypeTemp > 9
  INPUT "Exit type (0123456789) ... "; TypeTemp
WEND

IF Entered$ = "!n" THEN N(Location) = ExitTemp: NT(Location) = TypeTemp
IF Entered$ = "!s" THEN S(Location) = ExitTemp: ST(Location) = TypeTemp
IF Entered$ = "!e" THEN E(Location) = ExitTemp: ET(Location) = TypeTemp
IF Entered$ = "!w" THEN W(Location) = ExitTemp: WT(Location) = TypeTemp
IF Entered$ = "!u" THEN U(Location) = ExitTemp: UT(Location) = TypeTemp
IF Entered$ = "!d" THEN D(Location) = ExitTemp: DT(Location) = TypeTemp

IF ExitTemp > TotalLocations THEN TotalLocations = ExitTemp

PRINT "Done."
COLOR UserColor

BackWeGo10:
END SUB

FUNCTION DECRYPT$ (Coded$)

Temp$ = ""

FOR I = 1 TO LEN(Coded$)
  Letter = ASC(MID$(Coded$, I, 1))
  Temp$ = Temp$ + CHR$(INT(Letter / 2) + ((Letter MOD 2) * 128))
NEXT I

DECRYPT$ = Temp$

END FUNCTION

SUB DisplayError

SELECT CASE ERR

  CASE 2
    PRINT "Syntax error";

  CASE 3
    PRINT "RETURN without GOSUB";

  CASE 4
    PRINT "Out of Data";

  CASE 5
    PRINT "Illegal function call";

  CASE 6
    PRINT "Overflow";

  CASE 7
    PRINT "Out of Memory";

  CASE 9
    PRINT "Subscript out of range";

  CASE 10
    PRINT "Duplicate definition";

  CASE 11
    PRINT "Division by zero";

  CASE 13
    PRINT "TYPE Mismatch";

  CASE 14
    PRINT "Out of String space";

  CASE 16
    PRINT "String formula too complex";

  CASE 19
    PRINT "No Resume";

  CASE 20
    PRINT "RESUME without error";
   
  CASE 24
    PRINT "Device timeout";

  CASE 25
    PRINT "Device fault";

  CASE 27
    PRINT "Out of paper"
 
  CASE 39
    PRINT "CASE ELSE expected"
 
  CASE 40
    PRINT "Variable required"
 
  CASE 50
    PRINT "FIELD overflow"
 
  CASE 51
    PRINT "Internal error"
 
  CASE 52
    PRINT "Bad file name or number"
 
  CASE 53
    PRINT "File NOT found"
 
  CASE 54
    PRINT "Bad file mode"
 
  CASE 55
    PRINT "File already open"
 
  CASE 56
    PRINT "FIELD statement active"
 
  CASE 57
    PRINT "Device I/O error"
 
  CASE 58
    PRINT "File already exists"
 
  CASE 59
    PRINT "Bad Record length"
 
  CASE 61
    PRINT "Disk full"
 
  CASE 62
    PRINT "Input past end of file"
 
  CASE 63
    PRINT "Bad Record number"
 
  CASE 64
    PRINT "Bad file name"
 
  CASE 67
    PRINT "Too many files"
 
  CASE 68
    PRINT "Device unavailable"
 
  CASE 69
    PRINT "Communication buffer overflow"
 
  CASE 70
    PRINT "Permission denied"
 
  CASE 71
    PRINT "Disk NOT ready"
 
  CASE 72
    PRINT "Disk media error"
 
  CASE 73
    PRINT "Advanced features unavailable"
 
  CASE 74
    PRINT "Rename across disks"
 
  CASE 75
    PRINT "Path/File access error"
 
  CASE 76
    PRINT "Path NOT found"

END SELECT

END SUB

SUB DisplayHelp
 
COLOR SystemColor
IF Vocab > 0 THEN
  FOR I = 0 TO Vocab - 1
    IF POS(0) + LEN(V$(I)) = ScreenWidth - 1 THEN
      PRINT V$(I)
    ELSE
      IF POS(0) + LEN(V$(I)) > ScreenWidth - 2 THEN PRINT
      PRINT V$(I); " ";
    END IF
  NEXT I
  PRINT
ELSE
  PRINT "Sorry, no vocab ..."
END IF
 
COLOR UserColor
END SUB

SUB DisplayText (Text$)

GoAgain:

IF LEN(Text$) <= ScreenWidth THEN
  PRINT Text$
  ScrollCount = ScrollCount + 1
  IF ScrollCount = ScreenHeight THEN
    ScrollCount = 0
    DO
    LOOP WHILE INKEY$ = ""
  END IF
END IF

IF LEN(Text$) <= ScreenWidth THEN GOTO BackWeGo2
PRINT LEFT$(Text$, ScreenWidth);
ScrollCount = ScrollCount + 1
IF ScrollCount = ScreenHeight THEN
  ScrollCount = 0
  DO
  LOOP WHILE INKEY$ = ""
END IF

Text$ = RIGHT$(Text$, LEN(Text$) - ScreenWidth)
GOTO GoAgain

BackWeGo2:
END SUB

SUB DoExitStuff

number = 0

NE = CALCULATEEXIT(NT(Location), N(Location))
EE = CALCULATEEXIT(ET(Location), E(Location))
SE = CALCULATEEXIT(ST(Location), S(Location))
WE = CALCULATEEXIT(WT(Location), W(Location))
UE = CALCULATEEXIT(UT(Location), U(Location))
DE = CALCULATEEXIT(DT(Location), D(Location))

IF number = 0 THEN
  P1$ = "None."
  GOTO JumpAbove
ELSE
  P1$ = ""
END IF

IF NE = 1 THEN P1$ = "North": PunctuateExit
IF SE = 1 THEN P1$ = P1$ + "South": PunctuateExit
IF EE = 1 THEN P1$ = P1$ + "East": PunctuateExit
IF WE = 1 THEN P1$ = P1$ + "West": PunctuateExit
IF UE = 1 THEN P1$ = P1$ + "Up": PunctuateExit
IF DE = 1 THEN P1$ = P1$ + "Down": PunctuateExit

JumpAbove:

PRINT "Visible Exits: ";

IF LEN(P1$) < ScreenWidth - 15 THEN
  PRINT P1$
  GOTO BackWeGo6
END IF

P2$ = RIGHT$(P1$, LEN(P1$) - INSTR(P1$, "and") + 1)
P1$ = STRIPSINGLE$(P1$, P2$)
P1$ = LEFT$(P1$, LEN(P1$) - 1)
PRINT P1$
PRINT STRING$(15, " "); P2$

BackWeGo6:
END SUB

SUB DoObjectStuff

P1$ = Object1$          ' Place into strings for formatting and printing
P2$ = Object2$

' FOR I = 1 TO CarryNo
'  IF C$(I - 1) = P1$ THEN P1$ = "": GetFlag1 = 2
'  IF C$(I - 1) = P2$ THEN P2$ = "": GetFlag2 = 2
' NEXT I

IF GetFlag1 <> 2 THEN GetFlag1 = 1
IF Trig1(Location) = 1 AND ((LEFT$(Command1$, 3) = "get" AND INSTR(Command1$, "\") < 1) OR LEFT$(Command1$, 1) = "^") THEN P1$ = ""
IF Trig1(Location) = 1 AND ((LEFT$(Command1$, 4) = "&get" AND INSTR(Command1$, "\") < 1) OR LEFT$(Command1$, 2) = "&^") THEN P1$ = ""
IF Trig1(Location) = 1 AND INSTR(LEFT$(Trig1$, 2), "#") > 0 THEN P1$ = ""
IF INSTR(LEFT$(P1$, 2), "#") > 0 AND Trig2(Location) = 0 THEN P1$ = ""
IF P1$ = "" THEN GetFlag1 = 0

IF GetFlag2 <> 2 THEN GetFlag2 = 1
IF Trig2(Location) = 1 AND ((LEFT$(Command2$, 3) = "get" AND INSTR(Command2$, "\") < 1) OR LEFT$(Command2$, 1) = "^") THEN P2$ = ""
IF Trig2(Location) = 1 AND ((LEFT$(Command2$, 4) = "&get" AND INSTR(Command2$, "\") < 1) OR LEFT$(Command2$, 2) = "&^") THEN P2$ = ""
IF Trig2(Location) = 1 AND INSTR(LEFT$(Trig2$, 2), "#") > 0 THEN P2$ = ""
IF INSTR(LEFT$(P2$, 2), "#") > 0 AND Trig1(Location) = 0 THEN P2$ = ""
IF P2$ = "" THEN GetFlag2 = 0

IF GetFlag1 = 2 THEN GetFlag1 = 0
IF GetFlag2 = 2 THEN GetFlag2 = 0

IF AutoFlag = 1 THEN EXIT SUB

IF INSTR(LEFT$(P1$, 2), "@") > 0 OR LEFT$(P1$, 1) = "&" THEN P1$ = ""
IF INSTR(LEFT$(P2$, 2), "@") > 0 OR LEFT$(P2$, 1) = "&" THEN P2$ = ""

IF P1$ = "" AND P2$ = "" THEN
  PRINT
  PrintText ("You can see: Nothing.")
  GOTO BackWeGo4
END IF

IF P2$ = "" OR P1$ = "" THEN Objects = 1 ELSE Objects = 2
IF P1$ = "" THEN P1$ = P2$: P2$ = ""
P1$ = STRIPMANY$("#@", P1$): P2$ = STRIPMANY$("#@", P2$)

' Actual Sorting and Printing done from here on ...

PRINT
P3$ = "You can see: "

IF RIGHT$(P1$, 1) = "s" THEN
  P3$ = P3$ + "Some " + P1$
  GOTO Procede
END IF

IF INSTR("AaEeIiOoUu", LEFT$(P1$, 1)) > 0 THEN
  P3$ = P3$ + "An " + P1$
ELSE
  P3$ = P3$ + "A " + P1$
END IF

Procede:

IF Objects = 1 THEN
  P3$ = P3$ + "."
  PrintText (P3$)
  GOTO BackWeGo4
ELSE
  P1$ = ""
  P3$ = P3$ + " and "
END IF

IF RIGHT$(P2$, 1) = "s" THEN
  P1$ = "some " + P2$
  GOTO ProcedeAgain
END IF

IF INSTR("AaEeIiOoUu", LEFT$(P2$, 1)) > 0 THEN
  P1$ = "an " + P2$
ELSE
  P1$ = "a " + P2$
END IF

ProcedeAgain:

PRINT P3$;

IF (POS(0) + LEN(P1$) + 1) > ScreenWidth - 1 THEN
  PRINT
  PRINT STRING$(13, " "); P1$; "."
  GOTO BackWeGo4
END IF

IF POS(0) = ScreenWidth - 1 THEN
  PRINT P1$; ".";
  GOTO BackWeGo4
ELSE
  PRINT P1$; "."
  GOTO BackWeGo4
END IF

PRINT "."

BackWeGo4:
END SUB

SUB EditLocation

PRINT Location$(Location)

COLOR SystemColor
PRINT "> ";
OldTemp$(0) = Location$(Location)
Temp$ = LONGINPUT$

IF Temp$ = "*" THEN Location$(Location) = PrevLoc$
IF Temp$ <> "*" AND Temp$ <> "" THEN Location$(Location) = Temp$

COLOR UserColor
PRINT
PRINT Trigger$(Location)

COLOR SystemColor
PRINT "> ";
OldTemp$(0) = Trigger$(Location)
Temp$ = LONGINPUT$

IF Temp$ = "*" THEN Trigger$(Location) = PrevTrig$
IF Temp$ <> "*" AND Temp$ <> "" THEN Trigger$(Location) = Temp$

Trig1(Location) = 0: Trig2(Location) = 0
PrevLoc = -1
FinishedAutos = 0: AutoTrig = 0

CLS

END SUB

SUB EditOnly


END SUB

FUNCTION ENCRYPT$ (Uncoded$)

Temp$ = ""

FOR I = 1 TO LEN(Uncoded$)
 
  Letter = ASC(MID$(Uncoded$, I, 1))
  Temp = 0

  IF Letter > 127 THEN
    Letter = Letter - 128
    Temp = 1
  END IF
 
  Temp$ = Temp$ + CHR$(Letter * 2 + Temp)

NEXT I
    
ENCRYPT$ = Temp$

END FUNCTION

SUB FindVocab

Vocab = 0

FOR I = 0 TO TotalLocations
 
  Command1$ = RIGHT$(Trigger$(I), LEN(Trigger$(I)) - INSTR(Trigger$(I), ")"))
  Trig1$ = LEFT$(Command1$, INSTR(Command1$, ":"))
  Command1$ = RIGHT$(Command1$, LEN(Command1$) - LEN(Trig1$))
  Trig1$ = STRIPMANY$(":@#^", Trig1$)
  Trig2$ = STRIPMANY$("@#^", LEFT$(Command1$, INSTR(Command1$, "(") - 1))
  IF LEFT$(Trig1$, 1) = "&" THEN Trig1$ = ""
  IF LEFT$(Trig2$, 1) = "&" THEN Trig2$ = ""
 
  IF INSTR(Trig1$, " ") = 0 THEN
    Verb1$ = Trig1$
  ELSE
    Verb1$ = LEFT$(Trig1$, INSTR(Trig1$, " ") - 1)
  END IF
 
  IF INSTR(Trig2$, " ") = 0 THEN
    Verb2$ = Trig2$
  ELSE
    Verb2$ = LEFT$(Trig2$, INSTR(Trig2$, " ") - 1)
  END IF

  VerbFlag1 = -1
  VerbFlag2 = -1
  Verb1$ = LCASE$(Verb1$)
  Verb2$ = LCASE$(Verb2$)
  IF Verb1$ = Verb2$ THEN Verb2$ = ""

CheckVerb:

  FOR N = 0 TO Vocab
    IF V$(N) = Verb1$ OR Verb1$ = "" THEN VerbFlag1 = 1
    IF V$(N) = Verb2$ OR Verb2$ = "" THEN VerbFlag2 = 1
    IF VerbFlag1 = 1 AND VerbFlag2 = 1 THEN N = Vocab
  NEXT N

  IF VerbFlag1 = -1 AND STRIPMANY$(" ", Verb1$) <> "" THEN
    V$(Vocab) = STRIPMANY$(" ", Verb1$)
    Vocab = Vocab + 1
  END IF

  IF VerbFlag2 = -1 AND STRIPMANY$(" ", Verb2$) <> "" THEN
    V$(Vocab) = STRIPMANY$(" ", Verb2$)
    Vocab = Vocab + 1
  END IF

  Visited(I) = 0

NEXT I

END SUB

FUNCTION FORMATTEXT$ (Text$)

IF LEN(Text$) < ScreenWidth THEN
  FORMATTEXT$ = Text$
  GOTO BackWeGo3
ELSE
  Temp$ = ""
END IF

Again:

IF LEN(Text$) >= ScreenWidth THEN
  Line$ = LEFT$(Text$, ScreenWidth)
ELSE
  Line$ = Text$
END IF

IF INSTR(Text$, "\") <= ScreenWidth AND INSTR(Text$, "\") <> 0 THEN
  Temp$ = Temp$ + LEFT$(Text$, INSTR(Text$, "\"))
  Text$ = RIGHT$(Text$, LEN(Text$) - INSTR(Text$, "\"))
  GOTO Again
END IF

IF LEN(Text$) < ScreenWidth THEN
  Temp$ = Temp$ + Text$
  Text$ = ""
END IF

IF Text$ = "" THEN
  FORMATTEXT$ = Temp$
  GOTO BackWeGo3
END IF

Text$ = RIGHT$(Text$, LEN(Text$) - LEN(Line$))

IF Text$ <> "" AND LEFT$(Text$, 1) = " " THEN
  Text$ = RIGHT$(Text$, LEN(Text$) - 1)
  Temp$ = Temp$ + Line$
  GOTO Again
END IF

IF RIGHT$(Line$, 1) = " " THEN
  Line$ = LEFT$(Line$, LEN(Line$) - 1)
  Temp$ = Temp$ + Line$ + "\"
  GOTO Again
END IF

StripPos = LEN(Line$)

FOR I = LEN(Line$) TO 1 STEP -1
  IF MID$(Line$, I, 1) = " " THEN
    StripPos = I - 1
    I = 1
  END IF
NEXT I

Temp$ = Temp$ + LEFT$(Line$, StripPos) + "\"

IF StripPos < LEN(Line$) THEN
  Text$ = RIGHT$(Line$, LEN(Line$) - StripPos - 1) + Text$
END IF

GOTO Again

BackWeGo3:
END FUNCTION

FUNCTION GO$

Temp$ = ""

PRINT "Go (Y/N)? ";
WHILE NOT (Temp$ = "y" OR Temp$ = "n")
  Temp$ = LCASE$(INKEY$)
WEND
PRINT UCASE$(Temp$)
GO$ = Temp$

END FUNCTION

SUB GoToLocation

Where = VAL(RIGHT$(Entered$, LEN(Entered$) - 3))

IF Where >= 0 AND Where <= Max THEN
  IF Where > TotalLocations THEN TotalLocations = Where
  PrevLoc$ = Location$(Location)
  PrevTrig$ = Trigger$(Location)
  Location = Where
  COLOR SystemColor
  PRINT "Done."
  COLOR UserColor
ELSE
  PRINT "Too big."
END IF

END SUB

SUB Inventory

COLOR SystemColor

PRINT "You are carrying: ";

IF CarryNo = 0 THEN
  PRINT "nothing."
  GOTO BackWeGo12
END IF

Found = 0

FOR I = 1 TO CarryNo
  IF NOT (LEFT$(C$(I - 1), 1) = "&" AND EditFlag = 0) THEN
    Found = Found + 1
    IF I = 1 THEN
      PRINT C$(I - 1)
    ELSE
      PRINT "                  "; C$(I - 1)
    END IF
  END IF
NEXT I

IF Found = 0 THEN PRINT "nothing."

BackWeGo12:
COLOR UserColor
END SUB

SUB LoadAdventure

File$ = RIGHT$(Entered$, LEN(Entered$) - 5) + ".caw"

COLOR SystemColor
PRINT "Insert correct disc."
IF GO$ = "n" THEN GOTO BackWeGo14
  
OPEN File$ FOR INPUT ACCESS READ SHARED AS #1

INPUT #1, TotalLocations
IF TotalLocations > Max THEN
  COLOR SystemColor
  PRINT "Adventure too long."
  CLOSE #1
  GOTO BackWeGo14
END IF

PRINT "Please wait while the adventure is loaded ..."
INPUT #1, CodeFlag
IF CodeFlag <> 33 THEN
  CLOSE #1
  OPEN File$ FOR INPUT ACCESS READ SHARED AS #1
  INPUT #1, TotalLocations
END IF

FOR I = 0 TO TotalLocations
  LINE INPUT #1, Location$(I): LINE INPUT #1, Nothing$
  LINE INPUT #1, Trigger$(I): LINE INPUT #1, Nothing$
  INPUT #1, NT(I), ST(I), ET(I), WT(I), UT(I), DT(I), N(I), S(I), E(I), W(I), U(I), D(I)
NEXT I
INPUT #1, Password$
CLOSE #1

IF CodeFlag < 33 THEN GOTO SkipDecryption
FOR I = 0 TO TotalLocations
  Location$(I) = DECRYPT$(Location$(I))
  Trigger$(I) = DECRYPT$(Trigger$(I))
NEXT I

Password$ = DECRYPT$(Password$)

SkipDecryption:

FindVocab

Command1$ = "": Command2$ = ""
EditFlag = 0: EndFlag = 0
Location = 0: Explored = 0: MoveCounter = 0

FOR I = 0 TO TotalLocations
  Trig1(I) = 0
  Trig2(I) = 0
NEXT I

FOR I = 0 TO CarryNo - 1
  C$(I) = ""
NEXT I

CarryNo = 0

BackWeGo14:
COLOR UserColor
END SUB

SUB LoadPosition

File$ = RIGHT$(Entered$, LEN(Entered$) - 7) + ".sav"

COLOR SystemColor
PRINT "Insert correct disc."
IF GO$ = "n" THEN GOTO BackWeGo17

OPEN File$ FOR INPUT ACCESS READ SHARED AS #1

INPUT #1, SavedPosition, NumberOfLocations
IF NumberOfLocations <> TotalLocations THEN
  PRINT "Incompatible file."
  CLOSE #1
  GOTO BackWeGo17
END IF

Location = SavedPosition

INPUT #1, Explored
INPUT #1, MoveCounter

FOR I = 0 TO TotalLocations
  INPUT #1, Trig1(I)
  INPUT #1, Trig2(I)
  INPUT #1, Visited(I)
NEXT I

INPUT #1, CarryNo

FOR I = 0 TO CarryNo - 1
  INPUT #1, C$(I)
NEXT I

CLOSE #1

BackWeGo17:
COLOR UserColor
END SUB

SUB LocationError

COLOR SystemColor
PRINT "Error - Incorrectly defined location."
COLOR UserColor
ErrorFlag = 1

END SUB

FUNCTION LONGINPUT$

Temp$ = ""
TempPos = 0
TempLen = 0
LOCATE CSRLIN, POS(0), 1

WHILE Key$ <> CHR$(13)

  Key$ = ""

  WHILE LEN(Key$) = 0
    Key$ = INKEY$
  WEND

  IF Key$ = CHR$(27) THEN
    Temp$ = ""
    Key$ = CHR$(13)
  END IF

  IF Key$ = "|" THEN Key$ = "`"

  IF LEN(Key$) = 2 THEN
    TempKey = ASC(RIGHT$(Key$, 1))
    IF TempKey = 72 AND TempPos - ScreenWidth >= 0 THEN
      TempPos = TempPos - ScreenWidth
      LOCATE CSRLIN - 1, POS(0), 1
    END IF
    IF TempKey = 80 AND TempPos + ScreenWidth <= TempLen THEN
      TempPos = TempPos + ScreenWidth
      LOCATE CSRLIN + 1, POS(0), 1
    END IF
    IF TempKey = 75 AND TempPos > 0 THEN
      TempPos = TempPos - 1
      TempY = CSRLIN
      TempX = POS(0)
      TempX = TempX - 1
      IF TempX < 1 THEN
        TempX = ScreenWidth
        TempY = TempY - 1
      END IF
      LOCATE TempY, TempX, 1
    END IF
    IF TempKey = 77 AND TempPos < TempLen THEN
      TempPos = TempPos + 1
      TempY = CSRLIN
      TempX = POS(0)
      TempX = TempX + 1
      IF TempX > ScreenWidth THEN
        TempX = 1
        TempY = TempY + 1
      END IF
      LOCATE TempY, TempX, 1
    END IF
    IF TempKey = 82 AND Temp$ = "" THEN
      Temp$ = OldTemp$(0)
      TempLen = LEN(Temp$)
      TempPos = TempLen
      NormalPrint (Temp$)
    END IF
    IF TempKey = 83 AND TempPos <> TempLen THEN
      TempLen = TempLen - 1
      TempX = POS(0)
      TempY = CSRLIN
      LOCATE TempY, TempX, 0
      NormalPrint (RIGHT$(Temp$, TempLen - TempPos) + " ")
      LOCATE TempY, TempX, 1
      Temp$ = LEFT$(Temp$, TempPos) + RIGHT$(Temp$, TempLen - TempPos)
    END IF
    Key$ = ""
  END IF

  IF Key$ = CHR$(8) AND Temp$ <> "" AND TempPos > 0 THEN
    TempPos = TempPos - 1
    TempLen = TempLen - 1
    IF TempPos = TempLen THEN
      ShowBackspace
      Temp$ = LEFT$(Temp$, LEN(Temp$) - 1)
    ELSE
      TempX = POS(0) - 1
      TempY = CSRLIN
      IF TempX < 1 THEN TempX = ScreenWidth: TempY = TempY - 1
      LOCATE TempY, TempX, 0
      NormalPrint (RIGHT$(Temp$, TempLen - TempPos) + " ")
      LOCATE TempY, TempX, 1
      Temp$ = LEFT$(Temp$, TempPos) + RIGHT$(Temp$, TempLen - TempPos)
    END IF
  END IF

  IF Key$ <> CHR$(8) AND Key$ <> CHR$(13) AND Key$ <> "" THEN
    IF TempPos = TempLen THEN
      Temp$ = Temp$ + Key$
      PRINT Key$;
    ELSE
      PRINT Key$;
      TempX = POS(0)
      TempY = CSRLIN
      NormalPrint (RIGHT$(Temp$, TempLen - TempPos))
      Temp = LEN(RIGHT$(Temp$, TempLen - TempPos)) - 1
      Temp$ = LEFT$(Temp$, TempPos) + Key$ + RIGHT$(Temp$, TempLen - TempPos)
      LOCATE TempY, TempX, 1
      Temp = Temp - (ScreenWidth - TempX)
      IF Temp > 0 THEN
        IF TempY + Temp \ ScreenWidth - (Temp MOD ScreenWidth <> 0) > ScreenHeight - 1 THEN
          LOCATE TempY - 1, TempX, 1
        END IF
      END IF
    END IF
    TempPos = TempPos + 1
    TempLen = TempLen + 1
  END IF

WEND

TempStart = CSRLIN - (TempPos + 2) \ ScreenWidth
LOCATE (TempLen + 1) \ ScreenWidth + TempStart, (TempLen + 1) MOD ScreenWidth, 1
LONGINPUT$ = Temp$

END FUNCTION

SUB NoCanGo

COLOR SystemColor
PRINT "No can go!"
COLOR UserColor

END SUB

SUB NormalPrint (Tmp$)

DO
  TmpX = 81 - POS(0)
  IF LEN(Tmp$) > TmpX THEN
    PRINT LEFT$(Tmp$, TmpX);
    Tmp$ = RIGHT$(Tmp$, LEN(Tmp$) - TmpX)
  ELSE
    PRINT Tmp$;
    Tmp$ = ""
  END IF
LOOP UNTIL Tmp$ = ""

END SUB

SUB OK

COLOR SystemColor
PRINT "O.K."
COLOR UserColor

END SUB

SUB Pause (Delay!)

Delay! = TIMER + Delay!
WHILE TIMER >= Delay!
WEND

END SUB

FUNCTION PERCENTSCORE

IF TotalLocations = 0 THEN
  PERCENTSCORE = 100
ELSE
  PERCENTSCORE = INT(((Explored - 1) / TotalLocations) * 100)
END IF

END FUNCTION

SUB PrintLocationSheet

COLOR SystemColor
PRINT "Prepare printer."
IF GO$ = "n" THEN GOTO BackWeGo19

LPRINT
FOR I = 1 TO 15
  LPRINT "LOCATION:  "; CHR$(27); "-1"; STRING$(309, " "); CHR$(27); "-0";
NEXT I
LPRINT

BackWeGo19:
COLOR UserColor
END SUB

SUB PrintSquaredMap

COLOR SystemColor
PRINT "Prepare printer."
IF GO$ = "n" THEN GOTO BackWeGo18

Print$ = "!     !     !     !     !     !     !     !     !     !     !     !     !     !"

FOR I = 1 TO 12
  LPRINT STRING$(80, "-"); K$
  FOR N = 1 TO 3
    LPRINT K$
  NEXT N
NEXT I

LPRINT STRING$(80, "-")

BackWeGo18:
COLOR UserColor
END SUB

SUB PrintText (Text$)

Text$ = FORMATTEXT$(Text$)
ScrollCount = 0

PrintAgain:

IF INSTR(Text$, "\") = 0 THEN
  DisplayText (Text$)
  GOTO BackWeGo20
ELSE
  DisplayText (LEFT$(Text$, INSTR(Text$, "\") - 1))
  Text$ = RIGHT$(Text$, LEN(Text$) - INSTR(Text$, "\"))
END IF

IF Text$ <> "" THEN GOTO PrintAgain

BackWeGo20:
END SUB

SUB PrintTrigString
Trig$ = P1$

COLOR UserColor
Trig$ = RIGHT$(Trig$, LEN(Trig$) - INSTR(Trig$, "`"))

IF Trig$ = "#" THEN
  EndFlag = 1
  GOTO BackWeGo9
END IF

IF LEFT$(Trig$, 1) = "#" THEN
  EndFlag = 1
  Trig$ = RIGHT$(Trig$, LEN(Trig$) - 1)
  GOTO BackWeGo9
END IF

PrintText (Trig$)

BackWeGo9:
END SUB

SUB ProcessLocation

ErrorFlag = 0
D$ = Location$(Location)
Strip$ = RIGHT$(Trigger$(Location), LEN(Trigger$(Location)) - 1)

DoObject1:

IF INSTR(Strip$, ":") > 0 THEN
  Object1$ = LEFT$(Strip$, INSTR(Strip$, ":") - 1)
  Strip$ = RIGHT$(Strip$, LEN(Strip$) - (LEN(Object1$) + 1))
ELSE
  GOTO ErrorSub
END IF

IF LEFT$(Object1$, 1) <> "&" OR CarryNo = MaxCarry OR EditFlag = 1 OR (LEFT$(Object1$, 2) = "&#" AND Trig2(Location) = 0) THEN GOTO DoObject2
IF MID$(Object1$, 2, 1) = "#" THEN Object1$ = "&" + RIGHT$(Object1$, LEN(Object1$) - 2)
TestFlag = 0
FOR I = 0 TO CarryNo - 1
IF C$(I) = Object1$ THEN
  TestFlag = 1
  I = CarryNo - 1
END IF
NEXT I
IF TestFlag = 0 THEN
  C$(CarryNo) = Object1$
  CarryNo = CarryNo + 1
END IF

DoObject2:

IF INSTR(Strip$, ":") > 0 THEN
  Object2$ = LEFT$(Strip$, INSTR(Strip$, ":") - 1)
  Strip$ = RIGHT$(Strip$, LEN(Strip$) - (LEN(Object2$) + 1))
ELSE
  GOTO ErrorSub
END IF

IF LEFT$(Object2$, 1) <> "&" OR CarryNo = MaxCarry OR EditFlag = 1 OR (LEFT$(Object2$, 2) = "&#" AND Trig1(Location) = 0) THEN GOTO DoRest
IF MID$(Object2$, 2, 1) = "#" THEN Object2$ = "&" + RIGHT$(Object2$, LEN(Object2$) - 2)
TestFlag = 0
FOR I = 0 TO CarryNo - 1
IF C$(I) = Object2$ THEN
  TestFlag = 1
  I = CarryNo - 1
END IF
NEXT I
IF TestFlag = 0 THEN
  C$(CarryNo) = Object2$
  CarryNo = CarryNo + 1
END IF

DoRest:

IF INSTR(Strip$, ":") > 0 THEN
  D1$ = LEFT$(Strip$, INSTR(Strip$, ":") - 1)
  Strip$ = RIGHT$(Strip$, LEN(Strip$) - (LEN(D1$) + 1))
ELSE
  GOTO ErrorSub
END IF

IF INSTR(Strip$, ")") > 0 THEN
  D2$ = LEFT$(Strip$, INSTR(Strip$, ")") - 1)
  Strip$ = RIGHT$(Strip$, LEN(Strip$) - (LEN(D2$) + 1))
ELSE
  GOTO ErrorSub
END IF

IF INSTR(Strip$, ":") > 0 THEN
  Trig1$ = LEFT$(Strip$, INSTR(Strip$, ":") - 1)
  Strip$ = RIGHT$(Strip$, LEN(Strip$) - (LEN(Trig1$) + 1))
ELSE
  GOTO ErrorSub
END IF

IF INSTR(Trig1$, "`") = 0 THEN GOTO Continue1

P1$ = RIGHT$(Trig1$, LEN(Trig1$) - INSTR(Trig1$, "`"))
Trig1$ = LCASE$(LEFT$(Trig1$, INSTR(Trig1$, "`"))) + P1$

Continue1:

IF INSTR(Strip$, "(") > 0 THEN
  Trig2$ = LEFT$(Strip$, INSTR(Strip$, "(") - 1)
  Strip$ = RIGHT$(Strip$, LEN(Strip$) - (LEN(Trig2$) + 1))
ELSE
  GOTO ErrorSub
END IF

IF INSTR(Trig2$, "`") = 0 THEN GOTO Continue2

P1$ = RIGHT$(Trig2$, LEN(Trig2$) - INSTR(Trig2$, "`"))
Trig2$ = LCASE$(LEFT$(Trig2$, INSTR(Trig2$, "`"))) + P1$

Continue2:

IF INSTR(Strip$, ":") > 0 THEN
  DO$ = LCASE$(LEFT$(Strip$, INSTR(Strip$, ":") - 1))
  Strip$ = RIGHT$(Strip$, LEN(Strip$) - (LEN(DO$) + 1))
ELSE
  GOTO ErrorSub
END IF

IF INSTR(Strip$, ")") > 0 THEN
  DM$ = LEFT$(Strip$, LEN(Strip$) - 1)
  Strip$ = ""
ELSE
  GOTO ErrorSub
END IF

IF LEFT$(D2$, 1) = "#" AND Trig2(Location) = 1 THEN
  D$ = RIGHT$(D2$, LEN(D2$) - 1)
ELSE
  IF LEFT$(D1$, 1) = "#" AND Trig1(Location) = 1 THEN
    D$ = RIGHT$(D1$, LEN(D1$) - 1)
  END IF
END IF

IF Trig1(Location) = 1 AND LEFT$(D1$, 1) <> "#" AND D1$ <> "" THEN D$ = D$ + D1$
IF Trig2(Location) = 1 AND LEFT$(D2$, 1) <> "#" AND D2$ <> "" THEN D$ = D$ + D2$
Command1$ = STRIPMANY$("#@", Trig1$): Command2$ = STRIPMANY$("#@", Trig2$)

GOTO BackWeGo

ErrorSub:
LocationError

BackWeGo:
END SUB

SUB PunctuateExit

number = number - 1

IF number > 1 THEN P1$ = P1$ + ", "
IF number = 1 THEN P1$ = P1$ + " and "
IF number = 0 THEN P1$ = P1$ + "."

END SUB

SUB RemoveObject

Command1$ = RIGHT$(Entered$, LEN(Entered$) - 8)
IF Command1$ = "(all)" THEN
  CarryNo = 0
  COLOR SystemColor
  PRINT "Done."
  COLOR UserColor
  EXIT SUB
END IF

Found = -1

FOR I = 0 TO CarryNo - 1
  IF LCASE$(C$(I)) = Command1$ THEN
    Found = I
    I = CarryNo - 1
  END IF
NEXT I

COLOR SystemColor

IF Found = -1 THEN
  PRINT "You haven`t got it!"
ELSE
  FOR I = Found + 1 TO CarryNo - 1
    C$(I - 1) = C$(I)
  NEXT I
  CarryNo = CarryNo - 1
  C$(CarryNo) = ""
  PRINT "Done."
END IF

COLOR UserColor

END SUB

SUB RestoreFromRam

COLOR SystemColor

IF RT = -1 THEN
  PRINT "It helps if you RAMSAVE first!"
  GOTO BackWeGo13
END IF

IF RT <> TotalLocations THEN
  PRINT "Adventure incompatible ..."
  GOTO BackWeGo13
END IF

Location = RL
S = RY
M = RM
CarryNo = RX

FOR I = 0 TO CarryNo - 1
  C$(I) = RC$(I)
NEXT I

FOR I = 0 TO TotalLocations
  Trig1(I) = R1(I)
  Trig2(I) = R2(I)
  Visited(I) = RS(I)
NEXT I

PRINT "O.K."

BackWeGo13:
COLOR UserColor
END SUB

SUB SaveAdventure

File$ = RIGHT$(Entered$, LEN(Entered$) - 5) + ".caw"

COLOR SystemColor
PRINT "(C)oded or (U)ncoded saving? ";
SaveType$ = ""
DO
  SaveType$ = LCASE$(INKEY$)
LOOP UNTIL INSTR(" uc", SaveType$) > 1
PRINT UCASE$(SaveType$)

PRINT "Insert correct disc."
IF GO$ = "n" THEN
  COLOR UserColor
  GOTO BackWeGo15
END IF

' This bit strips down the adventure to find the last valid location number

TrueLocations = 0

FOR I = 0 TO TotalLocations
  IF N(I) > TrueLocations THEN TrueLocations = N(I)
  IF S(I) > TrueLocations THEN TrueLocations = S(I)
  IF E(I) > TrueLocations THEN TrueLocations = E(I)
  IF W(I) > TrueLocations THEN TrueLocations = W(I)
  IF U(I) > TrueLocations THEN TrueLocations = U(I)
  IF D(I) > TrueLocations THEN TrueLocations = D(I)
NEXT I

FOR I = TotalLocations TO TrueLocations STEP -1
  IF Location$(I) <> "" OR Trigger$(I) <> "(:::):(:)" THEN
    TrueLocations = I
    EXIT FOR
  END IF
NEXT I

IF TotalLocations <> TrueLocations THEN PRINT "Unused trailing locations trimmed."

' Now the saving bit

PRINT "Please wait while the adventure is saved ..."

OPEN File$ FOR OUTPUT ACCESS WRITE LOCK WRITE AS #1
PRINT #1, TrueLocations
IF SaveType$ = "c" THEN PRINT #1, 33
FOR I = 0 TO TrueLocations
  IF SaveType$ = "c" THEN PRINT #1, ENCRYPT$(Location$(I)) ELSE PRINT #1, Location$(I)
  PRINT #1, ""
  IF SaveType$ = "c" THEN PRINT #1, ENCRYPT$(Trigger$(I)) ELSE PRINT #1, Trigger$(I)
  PRINT #1, ""
  PRINT #1, NT(I): PRINT #1, ST(I): PRINT #1, ET(I): PRINT #1, WT(I): PRINT #1, UT(I): PRINT #1, DT(I)
  PRINT #1, N(I): PRINT #1, S(I): PRINT #1, E(I): PRINT #1, W(I): PRINT #1, U(I): PRINT #1, D(I)
NEXT I
IF SaveType$ = "c" THEN PRINT #1, ENCRYPT$(Password$) ELSE PRINT #1, Password$
CLOSE #1

BackWeGo15:

COLOR UserColor
END SUB

SUB SavePosition

COLOR SystemColor

File$ = RIGHT$(Entered$, LEN(Entered$) - 5) + ".sav"

COLOR SystemColor
PRINT "Insert correct disc."
IF GO$ = "n" THEN GOTO BackWeGo16

OPEN File$ FOR OUTPUT ACCESS WRITE LOCK WRITE AS #1

PRINT #1, Location
PRINT #1, TotalLocations
PRINT #1, Explored
PRINT #1, MoveCounter

FOR I = 0 TO TotalLocations
  PRINT #1, Trig1(I)
  PRINT #1, Trig2(I)
  PRINT #1, Visited(I)
NEXT I

PRINT #1, CarryNo

FOR I = 0 TO CarryNo - 1
  PRINT #1, C$(I)
NEXT I

CLOSE #1

BackWeGo16:
COLOR UserColor
END SUB

SUB SaveToRam

RL = Location
RT = TotalLocations
RY = S
RM = M
RX = CarryNo

FOR I = 0 TO CarryNo - 1
  RC$(I) = C$(I)
NEXT I

FOR I = 0 TO TotalLocations
  R1(I) = Trig1(I)
  R2(I) = Trig2(I)
  RS(I) = Visited(I)
NEXT I

COLOR SystemColor
PRINT "O.K."
COLOR UserColor

END SUB

DEFSNG A-Z
SUB SetFKeys

CR$ = CHR$(13)

KEY 1, "north" + CR$
KEY 2, "east" + CR$
KEY 3, "south" + CR$
KEY 4, "west" + CR$
KEY 5, "up" + CR$
KEY 6, "down" + CR$
KEY 8, "inventory" + CR$
KEY 9, "score" + CR$
KEY 10, "help" + CR$

END SUB

DEFINT A-Z
SUB SetNextLocation
   
PrevLoc$ = Location$(Location)
PrevTrig$ = Trigger$(Location)
FinishedAutos = 0
MoveCounter = MoveCounter + 1

END SUB

SUB ShowBackspace

x = POS(0)
y = CSRLIN

x = x - 1
IF x < 1 THEN x = ScreenWidth: y = y - 1

LOCATE y, x, 0
PRINT " ";
LOCATE y, x, 1

END SUB

DEFSNG A-Z
SUB ShowTitle

CLS
COLOR SystemColor: PRINT "C"; : COLOR UserColor: PRINT "reative ";
COLOR SystemColor: PRINT "A"; : COLOR UserColor: PRINT "dventure ";
COLOR SystemColor: PRINT "W"; : COLOR UserColor: PRINT "riter (PC Version 1.2)"
COLOR UserColor: PRINT "By "; : COLOR SystemColor: PRINT "Richard Hunt"
COLOR UserColor: PRINT

END SUB

DEFINT A-Z
SUB SoftInit

FOR I = 0 TO Max
  Visited(I) = 0
  N(I) = -1: S(I) = -1: E(I) = -1: W(I) = -1: U(I) = -1: D(I) = -1
  Location$(I) = "": Trigger$(I) = "(:::):(:)"
NEXT I

ClearFlag = 0
ScrollCount = 0
EditFlag = 0
CarryNo = 0
EndFlag = 0
Location = 0
TotalLocations = 0: GetFlag1 = 0: GetFlag2 = 0
Vocab = 0: Explored = 0: MoveCounter = 0: PrevLoc = -1
Password$ = "": PrevLoc$ = "": PrevTrig$ = "(:::):(:)"
C$(0) = "RICHARD HUNT IS BRILLIANT!"

FinishedAutos = 0: AutoTrig = 0

END SUB

FUNCTION STRIPMANY$ (Strip$, Source$)

Strippd$ = Source$

FOR Char = 1 TO LEN(Strip$)
  Char$ = MID$(Strip$, Char, 1)
  Working$ = Strippd$
  Strippd$ = ""
  FOR I = 1 TO LEN(Working$)
    Letter$ = MID$(Working$, I, 1)
    IF Letter$ <> Char$ THEN Strippd$ = Strippd$ + Letter$
  NEXT I
NEXT Char

STRIPMANY$ = Strippd$

END FUNCTION

FUNCTION STRIPSINGLE$ (Source$, Strip$)

Strippd$ = Source$
StripLen = LEN(Source$)

Strippd$ = ""

FOR I = 1 TO LEN(Source$)
  Letter$ = MID$(Source$, I, StripLen)
  IF Letter$ <> Strip$ THEN
    Strippd$ = Strippd$ + MID$(Source$, I, 1)
  ELSE
    I = I + StripLen - 1
  END IF
NEXT I

STRIPSINGLE$ = Strippd$

END FUNCTION

SUB UpdateAutoStatus

IF FinishedAutos = 0 THEN
  FinishedAutos = AutoTrig
  GOTO BackWeGo7
END IF

IF NOT ((AutoTrig = 1 AND FinishedAutos = 1) AND (AutoTrig = 2 AND FinishedAutos = 2)) THEN FinishedAutos = 3

BackWeGo7:
END SUB

SUB WipeExitOrLocation

COLOR SystemColor
PRINT "Wipe Location or Exit (L/E)? ";

Choice$ = ""

WHILE Choice$ <> "l" AND Choice$ <> "e"
  Choice$ = LCASE$(INKEY$)
WEND

PRINT UCASE$(Choice$)

IF Choice$ = "l" THEN GOTO WipeLocation

PRINT "Which exit (NSEWUD)? ";

Entered$ = ""
WHILE INSTR(" nsewud", Entered$) < 2
  Entered$ = LCASE$(INKEY$)
WEND

PRINT UCASE$(Entered$)

IF GO$ = "n" THEN GOTO BackWeGo11

IF Entered$ = "n" THEN NT(Location) = 0: N(Location) = -1: GOTO BackWeGo11
IF Entered$ = "s" THEN ST(Location) = 0: S(Location) = -1: GOTO BackWeGo11
IF Entered$ = "e" THEN ET(Location) = 0: E(Location) = -1: GOTO BackWeGo11
IF Entered$ = "w" THEN WT(Location) = 0: W(Location) = -1: GOTO BackWeGo11
IF Entered$ = "u" THEN UT(Location) = 0: U(Location) = -1: GOTO BackWeGo11
DT(Location) = 0: D(Location) = -1: GOTO BackWeGo11

WipeLocation:

IF GO$ = "y" THEN
  Location$(Location) = ""
  Trigger$(Location) = "(:::):(:)": Trig1(Location) = 0: Trig2(Location) = 0
  N(Location) = -1: S(Location) = -1: E(Location) = -1: W(Location) = -1: U(Location) = -1: D(Location) = -1
  NT(Location) = 0: ST(Location) = 0: ET(Location) = 0: WT(Location) = 0: UT(Location) = 0: DT(Location) = 0
END IF

BackWeGo11:
END SUB

